package hatelace.instructions;

import hatelace.*;

public class Add extends Instruction {
    private Address dest;
    private Operand o1, o2;

    /** Add immediate value to memory address. */
    public Add(Operand o1, Operand o2, Address dest) {
        this.o1 = o1;
        this.o2 = o2;
        this.dest = dest;
    }

    public void execute(Memory memory, ProgramCounter PC) {
        memory.write(this.dest, this.o1.getWord(memory).add(this.o2.getWord(memory)));
        PC.incPC();
    }

    protected String opcode() {
        return "ADD";
    }

    public String toString() {
        return String.format("%s [%s] %s [%s]", this.opcode(), this.o1, this.o2, this.dest);
    }

    protected Object[] operands() {
        return new Object[] { this.o1, this.o2, this.dest };
    }
}
