package hatelace.instructions;

import hatelace.*;

public class Copy extends Instruction {
    private Operand src;
    private Address dest;

    /** Copy immediate value to memory address. */
    public Copy(Operand src, Address dest) {
        this.src = src;
        this.dest = dest;
    }

    public void execute(Memory memory, ProgramCounter PC) {
        memory.write(this.dest, this.src.getWord(memory));
        PC.incPC();
    }

    protected String opcode() {
        return "CPY";
    }

    protected Object[] operands() {
        return new Object[] {this.src, this.dest};
    }

    public String toString() {
        return String.format("%s %s [%s]", this.opcode(), this.src, this.dest);
    }
}
