package hatelace.instructions;

import hatelace.*;

public class JumpEq extends Instruction {
    private int index;
    // private Address src;
    // private Word imm;
    private Operand o1;
    private Operand o2;

    /** Conditional jump */
    public JumpEq(int index, Operand o1, Operand o2) {
        this.index = index;
        this.o1 = o1;
        this.o2 = o2;
    }

    public void execute(Memory memory, ProgramCounter PC) {
        if (this.o1.getWord(memory).equals(this.o2.getWord(memory))) {
            PC.setPC(this.index);
        } else {
            PC.incPC();
        }
    }

    protected String opcode() {
        return "JEQ";
    }

    protected Object[] operands() {
        return new Object[] {this.index, this.o1, this.o2};
    }

    public String toString() {
        return String.format("%s %s [%s] %s", this.opcode(), this.index, this.o1, this.o2);
    }
}
