package hatelace.instructions;

import hatelace.*;

public class Mul extends Instruction {
    private Operand o1;
    private Operand o2;
    private Address dest;

    /** Multiply contents of two addresses and store the result in a third memory address. */
    public Mul(Operand o1, Operand o2, Address dest) {
        this.o1 = o1;
        this.o2 = o2;
        this.dest = dest;
    }

    public void execute(Memory memory, ProgramCounter PC) {
        memory.write(this.dest, this.o1.getWord(memory).multiply(this.o2.getWord(memory)));
        PC.incPC();
    }

    protected String opcode() {
        return "MUL";
    }

    protected Object[] operands() {
        return new Object[] { this.o1, this.o2, this.dest };
    }

    public String toString() {
        return String.format("%s [%s] [%s] [%s]", this.opcode(), this.o1, this.o2, this.dest);
    }
}
